''***********************************************
'' ZCL_OnOff 
'' ZigBee On/Off Cluster ID 0x0006 See Page 125 of ZigBee Cluster Library (ZCL)           
'' Author: John.Rucker@Solar-Current.com
'' Copyright (c) 2014 Solar-Current.com, Inc.
'' See end of file for terms of use.
''***********************************************
''-----------------REVISION HISTORY-----------------
'' 1 -  10/14/2014 Created by John Rucker

Dat
        Switch          Byte    $00             ' 00 = Switch is Off, 01 = Switch is On

OBJ
  zb            : "ZigBeeAPI"                           ' Object is placed here as a stub allowing access to the ZigBeeAPI object.

Pub RouteCmd (zbPktPtr, ReturnBufAdd, MaxReturnBufSize) | frmType, seqNum, cmdID, attributeID
  frmType:=seqNum:=cmdID:=attributeID:=0 
  '*************************************** 
  ' Routes execution based on FrmType and CmdID
  ' zbPktPtr is a the address of a buffer containing the payload of the ZigBee packet to process
  ' ReturnBufAdd is the address of a byte sized buffer to place the response bytes into
  ' Return is passed back from called method
  '***************************************
  frmType := byte[zbPktPtr][0]                                                                          ' Frame Type is bit 0 and 1 of Byte 0 P14 of ZCL. if cmd = 00 command is defind in table 2.9 P16, if cmd = 01 command is defind in the cluster's cmd list 
  frmType &= %00000000_00000001                                                                         ' Bitwise (&) with a mask to make sure we are looking at last bit
  seqNum := byte[zbPktPtr][1]                                                                           ' Transaction seq number can be any value used in return packet to match a response to a request

  cmdID := byte[zbPktPtr][2]                                                                            ' Command ID Byte P16 of ZCL
  byte[@attributeID][0] := byte[zbPktPtr][3]                                                            ' Attribute ID Word(little endin) P126 of ZCL
  byte[@attributeID][1] := byte[zbPktPtr][4]
  
  if FrmType == 0                                                                                       ' Command is profile wide command
    case CmdID
      $00: return ReadAttribute(attributeID, seqNum, ReturnBufAdd, MaxReturnBufSize)                    ' Read attribute
  else
    return ClusterCmd(ZbPktPtr, seqNum, ReturnBufAdd, MaxReturnBufSize, CmdID)                          ' Cluster Specific command

  return FALSE

Pub IsSwitchOn
  '*************************************** 
  ' Returns True if Switch is on, False if off
  '***************************************
  if Switch == 1
    return TRUE
  else
    return FALSE                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            

Pri ClusterCmd(zbDataPtr, seqNum, BufAdd, MaxBufSize,  CmdID) | BufSize
  '*************************************** 
  ' Sets Switch setting based on Setting variable
  ' Returns default response back to originator
  '***************************************
  case CmdID
    $00:                                                                        ' Set Switch Off
      Switch := 0
                                                                     
    $01:                                                                        ' Set Switch On
      Switch := 1
      
    $02:                                                                        ' Toggle Switch
      if Switch == 1
        Switch :=10
      else
        Switch := 1
        
  '** Send Response to Command
  BufSize := 5
  if BufSize > MaxBufSize
    return -1  
  ByteFill(BufAdd, 0 , MaxBufSize)                                              ' Clear Buffer
  byte[BufAdd][0] := $18                                                        ' Fame Control $18 = direction is from server to client, disable default response P14 of ZCL
  byte[BufAdd][1] := seqNum                                                     ' Set the sequence number to match the seq number in requesting packet
  byte[BufAdd][2] := $0B                                                        ' Command Identifer $0B = Default response see Table 2.9 on page 16 of ZCL
   
  byte[BufAdd][3] := CmdID                                                      ' CmdID to report
  byte[BufAdd][4] := $00                                                        ' $00 = Success                                                            
   
  zb.TX(zb._PktIEEEAddHi, zb._PktIEEEAddLo, zb._PktNetAdd, zb._PktDEP, zb._PktSEP, zb._PktProfile, zb._PktCluster, bufAdd, BufSize)
  return TRUE

Pri ReadAttribute(Attribute, seqNum, BufAdd, MaxBufSize) | BufSize 
  '*************************************** 
  ' Reads Attribute Number creates response and places it in BufAdd
  ' Attribute = Attribute to report on
  ' seqNum = sequence number used in creating response packet
  ' BufAdd = Pointer to a byte sized buffer to place the response packet in
  ' MaxBufSize = Maximum Size of buffer
  ' Returns true if successful false if error
  '***************************************
  BufSize := 8                                                                  ' BufSize is the size of the response pkt placed inside the BufAdd buffer in bytes 
  if Attribute == $0000                                                         ' Read Current level see page 133 of ZCL
    if BufSize > MaxBufSize
      return -1  
    ByteFill(BufAdd, 0 , MaxBufSize)                                            ' Clear Buffer
    byte[BufAdd][0] := $18                                                      ' Fame Control $18 = direction is from server to client, disable default response P14 of ZCL
    byte[BufAdd][1] := seqNum                                                   ' Set the sequence number to match the seq number in requesting packet
    byte[BufAdd][2] := $01                                                      ' Command Identifer $01 = Read attribute response see Table 2.9 on page 16 of ZCL
    
    byte[BufAdd][3] := byte[@Attribute][0]                                      ' Attribute Identifier (2 bytes) field being reported see figure 2.24 on page 36 of ZCL
    byte[BufAdd][4] := byte[@Attribute][1]                                                            
    
    byte[BufAdd][5] := $00                                                      ' Status 00 = Success
    
    byte[BufAdd][6] := $10                                                      ' Attribute Data Type $10 = Boolean, see table 2.16 on page 54 of ZCL

    byte[BufAdd][7] := Switch
    zb.TX(zb._PktIEEEAddHi, zb._PktIEEEAddLo, zb._PktNetAdd, zb._PktDEP, zb._PktSEP, zb._PktProfile, zb._PktCluster, bufAdd, BufSize)
    return TRUE

  return FALSE
        
        